<div class="gray-box form"  >
    <fieldset style="padding-bottom: 20px">
		<legend><?= $this->t('your_premium_models') ?></legend>
		<div class="body">
            <div class="tbl"><?= json_encode($this->package) ?></div>
            <div class="clear"></div>
		</div>
	</fieldset>

    <script type="text/javascript">

		$$('.tbl .data').each(function (element) {
			var data = JSON.decode(element.get('html'), true);

			element.getNext('button').store('data', data);
			element.destroy();
		});

		var Premium = {
			loaded: { escorts: false, cities: false },
			update: function () {
				if ( this.loaded['escorts'] && this.loaded['cities'] ) {
					Navigation.enable();
				}
				else {
					Navigation.disable();
				}
			},

			Escorts: new Class({

				Implements: [Events],

				buttons: {},

				columns: [],
				element: null,
				head: null,
				body: null,

				initialize: function (columns, element) {
					this.columns = columns;
					this.element = element;

					var data = JSON.decode(this.element.get('html'));

					this.element.empty();

					this.render();

					this.load(data);
				},

				render: function () {
					this.head = new Element('div', { 'class': 'row head' }).inject(this.element);
					this.columns.each(function (column, i) {
						new Element('div', { 'class': 'col col' + (i + 1) + ( i + 1 == this.columns.length ? ' last' : ''), html: column.title }).inject(this.head);
					}.bind(this));
					this.body = new Element('div', { 'class': 'row-body' }).inject(this.element);
				},

				even: false,
				renderRow: function (data) {
					this.even = ! this.even;
					var r = new Element('div', { 'class': 'row ' + (this.even ? 'even' : 'odd') });
					this.columns.each(function (column, i) {
						var c = new Element('div', { 'class': 'col col' + (i + 1) });
						if ( $defined(column.func) ) {
							var res = column['func'](data, c);
							if ( res ) c.set('html', res);
							else c.set('html', '&nbsp;');
						}
						else {
							if ( data[column.field] ) {
								c.set('html', data[column.field]);
							}
							else {
								c.set('html', '&nbsp;');
							}
						}
						c.inject(r);
					}.bind(this));

					new Element('div', { 'class': 'clear' }).inject(r);

					r.store('data', data);

					return r;
				},

				init: function () {

				},

				load: function (data) {
					this.body.empty();
                    var row;
					var r = this.renderRow(data).inject(this.body);

                    var btn = new Element('button').addEvent('click', this.onClick.bindWithEvent(this));
                    new Element('img', { src: _st('_/btn_save-small.gif') }).inject(btn);
                    btn.inject(r, 'after');


                    row = r;

                    if ( row.retrieve('editting') ) {
                        return this.actionSave(row);
                    }

                    Premium.revert();
                    row.store('editting', true);

                    var cols = row.getElements('.col'),
                        data = row.retrieve('data');

                    this.oldRow = row.clone();
                    this.currentRow = row;

                    Premium.loaded = { escorts: false, cities: false };
                    Premium.update();

                    cols[1].empty();
                    select = new Element('select', {  }).inject(cols[1]);


                    Premium.fetchEscorts(select, data.id);
                    var escortCounter = 0;
                    select.addEvent('change', function () {
                       

                        if ( (data.cities && Premium.loaded.escorts) || (escortCounter == 0 && data.cities)) {
                            
                            Premium.fetchCities(this.getSelected()[0].get('value').toInt(), cols[2]);
                        }
                        else {
                            Premium.loaded.cities = true;
                        }

                        escortCounter++;
                        
                    });

				},

				onClick: function (e) {
                    if(e.target.getParent('button')){
                        this.fireEvent('click', [e.target.getParent('button').getPrevious('.row'), this.data]);
                    }else{
                        this.fireEvent('click', [e.target.getPrevious('.row'), this.data]);
                    }

				},

				onEdit: function () {

				},

				onSave: function () {

				}
			}),

			cities: function (row, col) {
				if ( ! $defined(row.cities) ) {
					return '-';
				}

				var cities = [];
				row.cities.each(function (city) {
					cities.include(city.is_base ? ('<span class="strong">' + city.title + '</span>') : city.title);
				});
				return cities.join(', ');
			},

			expires: function (row) {
				return row.expires + ' <?= $this->t('days') ?>';
			},

			currentRow: null,
			oldRow: null,

			actionEdit: function (row) {

				if ( row.retrieve('editting') ) {
					return this.actionSave(row);
				}
 
			},

			actionSave: function (row) {

				var cols = row.getElements('.col'),
					data = row.retrieve('data');

				var selected = cols[2].getElements('input:checked'),
					city_ids = [];


                 

				selected.each(function (sel) {
					city_ids.include(sel.get('value').toInt());
				});

				var old_escort_id = data.id,
					new_escort_id = cols[1].getElement('select').getSelected()[0].get('value').toInt();

				var params = {
					city_ids: city_ids,
					from_escort_id: old_escort_id,
					to_escort_id: new_escort_id
				};
                  
				this.currentRow = null;
				this.oldRow = null;

				Premium.loaded = { escorts: false, cities: false };
				Premium.update();
				new Request({
					url: '/<?= $this->lang() ?>/private-v2/ajax-premium-switch',
					data: params,
					onSuccess: function (resp) {
						resp = JSON.decode(resp, true);

						if ( resp.status != 'success' ) {
							//page_overlay.enable();
							alert(resp.error);
							//return this.revert();
						}

						 $$('.Agencyescort-wrapper').destroy();
                        page_overlay.enable();


                        Cubix.Agencyescort.Load('<?= $this->lang() ?>',pagerActive, 1);
                        Cubix.Agencyescort.Load('<?= $this->lang() ?>', pagerInactive);

                        Premium.loaded = { escorts: true, cities: true };
                        Premium.update();
					}.bind(this)
				}).send();
			},

			revert: function () {
				if ( ! this.oldRow || ! this.currentRow ) return;
				var btn = this.currentRow.getNext('button'),
					i = btn.getElement('img');

				i.set('src', i.get('src').replace('btn_save', 'btn_edit'));

				this.oldRow.store('data', this.currentRow.retrieve('data'));
				this.oldRow.store('editting', false);
				this.oldRow.replaces(this.currentRow);
				this.currentRow.destroy();

				this.oldRow = null;
				this.currentRow = null;
			},

			fetchEscorts_request: false,
			fetchEscorts: function (element, selected) {
				element.empty();
				element.set('disabled', 'disabled');

				if ( ! this.request ) {}

				if ( this.fetchEscorts_request ) this.fetchEscorts_request.cancel();
				this.fetchEscorts_request = new Request({
					url: '/<?= $this->lang() ?>/private-v2/ajax-escorts',
					method: 'get',
					onSuccess: function (data) {
						data = JSON.decode(data, true);
						if ( ! data.length ) return;
						data.each(function (item) {
                            
							new Element('option', {
								value: item.id,
								html: item.showname+ '&nbsp;&nbsp;',
								selected: (selected == item.id) ? 'selected' : null
							}).inject(element);
							element.set('disabled', null);
							element.fireEvent('change');
						});
						Premium.loaded.escorts = true;
						Premium.update();
					}
				}).send();
			},

			fetchCities_request: false,
			fetchCities: function (escort_id, element) {
				new Request({
					url: '/<?= $this->lang() ?>/private-v2/ajax-escort-cities',
					data: { escort_id: escort_id },
					onSuccess: function (resp) {
						resp = JSON.decode(resp, true);

						element.empty();

						var limit = resp.limit;

						resp.cities.working.each(function (city) {
							var found = false; if ( resp.cities.premium ) { for ( var i = 0; i < resp.cities.premium.length; i++ ) { if ( resp.cities.premium[i].id == city.id ) { found = true; break; } } }
							var l = new Element('label', { 'class': city.is_base ? 'base' : null });
							new Element('input', { type: 'checkbox', value: city.id, checked: found ? 'checked' : null }).addEvent('change', function (e) {
								var val = this.get('checked'),
									count = this.getParent().getElements('input:checked');
								if ( val && count > limit ) {
									val.set('checked', '');
								}
							}).inject(l);
							new Element('span', { html: city.title }).inject(l);
							l.inject(element);
						});

						Premium.loaded.cities = true;
						Premium.update();
					}
				}).send();
			}
		};

	</script>
</div>